//翻译资源加载提示框
var translate_load_div = undefined;
//google翻译inforbar     
var google_translate_iframe = undefined; 
//目标语言   
var set_target_language = undefined;
//包括语言选择的div       
var select_language_div = undefined;
//翻译目标语言选择器   
var language_select = undefined;
//是否已经取消翻译        
var canceled_translate = false;
//检查当前目标语言的timer       
var check_target_language_timer = undefined;
//首次加载时使用的临时翻译语言
var tmp_target_language1 = 'en';
var tmp_target_language2 = 'ja';
//是否点击关闭按钮
var chick_close_button = false;
//关闭调试信息
var debug_log_close = true;

//封装java端回调
function translatePrint(infor) {
    if (debug_log_close)
        return;

    if (typeof __injectionJavaScriptObject___ !== "undefined" && __injectionJavaScriptObject___.print) {
        __injectionJavaScriptObject___.print(infor);
    } else {
        var jesion = {"class_name": "com.ijinshan.browser.KInjectionJavaScriptObject", "params": {"function_name": "print","log": infor,}, "sync": false,};
        prompt(JSON.stringify(jesion), "3.1415926535");
    }
}

function getTranslateTargetLanguageCode() {
    if (typeof __injectionJavaScriptObject___ !== "undefined" && __injectionJavaScriptObject___.getTranslateTargetLanguageCode) {
        return __injectionJavaScriptObject___.getTranslateTargetLanguageCode();
    } else {
        var jesion = {"class_name": "com.ijinshan.browser.KInjectionJavaScriptObject", "params": {"function_name": "translateTargetLanguageCode",}, "sync": true,};
        jesion = prompt(JSON.stringify(jesion), "3.1415926535");
        jesion = JSON.parse(jesion);
        return jesion.translateTargetLanguageCode;
    }
}

function setTranslateTargetLanguageCode(language) {
    if (typeof __injectionJavaScriptObject___ !== "undefined" && __injectionJavaScriptObject___.setTranslateTargetLanguageCode) {
        __injectionJavaScriptObject___.setTranslateTargetLanguageCode(language);
    } else {
        var jesion = {"class_name": "com.ijinshan.browser.KInjectionJavaScriptObject", "params": {"function_name": "setTranslateTargetLanguageCode","translateTargetLanguageCode": language,}, "sync": true,};
        prompt(JSON.stringify(jesion), "3.1415926535");
    }
}

function getTranslateLoadingTip() {
    if (typeof __injectionJavaScriptObject___ !== "undefined" && __injectionJavaScriptObject___.getTranslateLoadingTip) {
        return __injectionJavaScriptObject___.getTranslateLoadingTip();
    } else {
        var jesion = {"class_name": "com.ijinshan.browser.KInjectionJavaScriptObject", "params": {"function_name": "translateLoadingTip",}, "sync": true,};
        jesion = prompt(JSON.stringify(jesion), "3.1415926535");
        jesion = JSON.parse(jesion);
        return jesion.translateLoadingTip;
    }
}

//提供google翻译回调函数
function googleTranslateElementInit() {
    translatePrint("googleTranslateElementInit");
    new google.translate.TranslateElement(
        {pageLanguage: '', layout: google.translate.TranslateElement.FloatPosition.TOP_LEFT},
        'google_translate_element');

    //开始检查GoogleTranslateBar和LanguageSelect
    checkGoogleTranslateBar();
    checkLanguageSelect();
}

//检测GoogleTranslateBar
function checkGoogleTranslateBar() {
    translatePrint("checkGoogleTranslateBar");
    var find_google_translate_iframe_timer = setInterval(function() {
        google_translate_iframe = document.getElementById(':1.container');
        translatePrint("find_google_translate_iframe_timer google_translate_iframe=" + google_translate_iframe);
        //google_translate_iframe不为空，并且body的top为40
        if(google_translate_iframe && document.body.style.top == '40px') {
            clearInterval(find_google_translate_iframe_timer);
            hideLoadDiv();

            //设置google_translate_iframe的样子
            setGoogleTranslateBar();
        } else {
            google_translate_iframe = null;
        }
    }, 200);
}

function startCheckTargetLanguage() {
    if(typeof check_target_language_timer != 'undefined')
        return;
    translatePrint("check_target_language_timer create");
    check_target_language_timer = setInterval(function() {
        setTranslateTargetLanguageCode(language_select.value);
    }, 1000);
}

function stopCheckTargetLanguage() {
    if (typeof check_target_language_timer != 'undefined') {
        translatePrint("check_target_language_timer release");
        clearInterval(check_target_language_timer);
        check_target_language_timer = undefined;
    }
}

//设置google translate bar
function setGoogleTranslateBar() {
    translatePrint("setGoogleTranslateBar");
    google_translate_iframe.style.position = 'relative';
    document.body.style.top = 0;

    var close_button = google_translate_iframe.contentDocument.querySelector('#\\:1\\.close');
    close_button.addEventListener('click', function(){
        chick_close_button = true;
    }, false);

    var close_menu_iframe = document.querySelectorAll('iframe.goog-te-menu-frame')[1];
    var clost_menu = close_menu_iframe.contentDocument.querySelectorAll('.goog-te-menu2-item')[1];
    clost_menu.addEventListener('click', function(){
        chick_close_button = true;
    }, false);

    if(canceled_translate)
        cancelTranslatePageDo();
}

function hideLoadDiv() {
    translate_load_div.style.display = 'none';
}

function checkLanguageSelect() {
    translatePrint("checkLanguageSelect");
    var find_language_select_timer = setInterval(function() {
        language_select = document.querySelector('.goog-te-combo');
        translatePrint("find_language_select_timer language_select=" + language_select);
        if (language_select && language_select.length > 0) {
            clearInterval(find_language_select_timer);
            setLanguageSelect();
        }
    }, 200);
}

function setLanguageSelect() {
    translatePrint("setLanguageSelect");
    function language_change_do() {
        translatePrint("language_select.value=" + language_select.value);
        translatePrint("set_target_language=" + set_target_language);
        if (canceled_translate)
            restoreTranslatePage();
        if (chick_close_button) {
            chick_close_button = false;
            document.body.style.top = 0;
        }
    }
    //language_select由系统选择或者通过google_translate_iframe修改语言时，接收不到change事件
    language_select.addEventListener('change', language_change_do, false);

    //google翻译启动的三种情况：
    //1.没有翻译过,google翻译不做任何处理只显示语言选择框,并不添加google_infor_bar
        //当language_select初始化完成就可以，可以手动触发翻译，时机不好把握
    //2.翻译过,直接按照其翻译过的语言翻译,最后的翻译语言==当前要翻译
        //当手动触发翻译时，有时无法翻译，原因估计是系统自动发动的翻译消息和我们发动的冲突
    //3.翻译过,直接按照其翻译过的语言翻译,最后的翻译语言!=当前要翻译
        //当language_select初始化完成就可以，可以手动触发翻译
    //最终解决:当language_select初始化完成，先使用非目标语言翻译，再使用目标语言翻译
    translateToTargetLanguageLater();
}

function translateToTargetLanguageLater() {
    setTimeout(function(){
        if(set_target_language != tmp_target_language1)
            selectTranslateLanguage(tmp_target_language1);
        else
            selectTranslateLanguage(tmp_target_language2);
        setTimeout(function(){
            selectTranslateLanguage(set_target_language);
            startCheckTargetLanguage();
        }, 100);
    }, 100);
}

//选择翻译语言
function selectTranslateLanguage(language_code) {
    translatePrint("selectTranslateLanguage:" + language_code);
    language_select.value = language_code;
    var change_event = document.createEvent('HTMLEvents');
    change_event.initEvent('change', false, true);
    language_select.dispatchEvent(change_event);
}

//取消翻译
function cancelTranslatePage() {
    canceled_translate = true;
    translate_load_div.style.display = 'none';
    if(google_translate_iframe)
        cancelTranslatePageDo();
    else
        return;
}

function cancelTranslatePageDo() {
    translatePrint("cancelTranslatePageDo");
    google_translate_iframe.style.display = 'none';
    restoreTranslatePage();
    select_language_div.style.display = 'none';
}

function restoreTranslatePage() {
    translatePrint("restoreTranslatePage");
    stopCheckTargetLanguage();
    var click_event = document.createEvent('HTMLEvents');
    click_event.initEvent('click', false, true);
    google_translate_iframe.contentDocument.querySelector('#\\:1\\.restore').dispatchEvent(click_event);
}

//翻译资源加载提示
function addLoadDiv() {
    translate_load_div = document.createElement('div');
    translate_load_div.id='translate_load_div';
    translate_load_div.style.position = 'relative'; //这里需要判断如何postion
    translate_load_div.style.top = '0px';
    translate_load_div.style.left = '0px';
    translate_load_div.style.zIndex = '100000';
    translate_load_div.style.backgroundColor = '#FFFFFF';
    translate_load_div.style.width = '100%';
    translate_load_div.style.height = '73px';
    translate_load_div.style.borderBottomStyle = 'solid';
    translate_load_div.style.borderBottomColor = '#BFBFBF';
    translate_load_div.style.borderBottomWidth = '1px';

    translate_png_img = document.createElement('img');
    translate_png_img.style.position = 'absolute';
    translate_png_img.src = "liebiao/cmcm/translate.png";
    //translate_png_img.src = "file:///android_asset/translate.png";
    translate_png_img.style.top = '15px';
    translate_png_img.style.left = '19px';
    translate_png_img.style.width = '42px';
    translate_png_img.style.height = '42px';
    translate_load_div.appendChild(translate_png_img);

    translate_load_text_p = document.createElement('span');
    translate_load_text_p.textContent = getTranslateLoadingTip();
    translate_load_text_p.style.position = 'absolute';
    translate_load_text_p.style.top = '28px';
    translate_load_text_p.style.left = '78px';
    translate_load_text_p.style.fontSize = '17px';
    translate_load_text_p.style.color = '#000000';
    translate_load_div.appendChild(translate_load_text_p);

    bodyfirstNode=document.body.childNodes[0];
    document.body.insertBefore(translate_load_div, bodyfirstNode);
}

//添加和创建google翻译需要的内容
function googleTranslateLaod(){
    //设置翻译目标语言
    set_target_language = getTranslateTargetLanguageCode();

    //添加加载条
    addLoadDiv();

    translatePrint("insert meda_node");
    //创建google翻译需要的meda，并插入head
    var meda_node = document.createElement('meta');
    meda_node.name = 'google-translate-customization';
    meda_node.content = '3fdd76b50a06aff8-1f12d71477f9a190-g73c7a42161787c14-21'; 
    document.head.appendChild(meda_node);

    translatePrint("insert language_div");
    //添加语言选择框div
    select_language_div = document.createElement('div');
    select_language_div.id = 'google_translate_element';
    select_language_div.style.top = '100px';
    select_language_div.style.left = '10px';
    //select_language_div.style.display = 'none';
    select_language_div.style.zIndex = '99999';
    bodyfirstNode=document.body.childNodes[0];
    document.body.insertBefore(select_language_div, bodyfirstNode);

    translatePrint("insert google_url_js");
    //添加google翻译启动js
    var translate_load_script = document.createElement('script');
    translate_load_script.type = 'text/javascript';
    translate_load_script.src = 'https://translate.google.com/translate_a/element.js?cb=googleTranslateElementInit';
    document.body.appendChild(translate_load_script);
};

googleTranslateLaod();

function translatePage(language) {
    canceled_translate = false;
    set_target_language = language;
    if(language_select) {
        startCheckTargetLanguage();
        selectTranslateLanguage(set_target_language);
        select_language_div.style.display = 'block';
        google_translate_iframe.style.display = 'block';
    }
}
